<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nickname</label>

            <b-form-select
              v-model="filter.nickname"
              :options="formattedProjectOptions"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Owner</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.ownerName"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nama Proyek</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.projectName"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nomor Kontrak</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.contractNumber"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Status</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.status"
              disabled
            ></b-form-input>
          </div>
        </div>
      </div>

      <div class="d-flex justify-content-end pb-3">
        <div>
          <b-button
            v-if="currentEditId"
            class="ml-auto mr-2"
            variant="success"
            @click="save"
          >
            <i class="flaticon2-check-mark"></i> Simpan
          </b-button>

          <b-button class="ml-auto" variant="success" @click="loadData">
            Load Design
          </b-button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-4 offset-8">
            <div class="input-group mb-5">
              <div class="input-group-prepend">
                <span class="input-group-text line-height-0 py-0">
                  <i class="flaticon2-search-1"></i>
                </span>
              </div>

              <input
                type="text"
                class="form-control"
                aria-describedby="basic-addon2"
              />
            </div>
          </div>
        </div>

        <complete-table :loading="loading" :data="currentAsBuiltDrawings">
          <template #header>
            <tr class="text-left">
              <th style="min-width: 250px" class="pl-7">
                <span class="text-dark-75">Numbering</span>
              </th>
              <th style="min-width: 200px">External Numbering</th>
              <th style="min-width: 250px">Asbuilt Drawing Numbering</th>
              <th style="min-width: 250px">Title</th>
              <th style="min-width: 100px">Stasiun</th>
              <th style="min-width: 100px">Type</th>
              <th style="min-width: 100px">Scope</th>
              <th style="min-width: 150px">Status</th>
              <th style="min-width: 100px">Revisi</th>
              <th style="min-width: 150px">Versi</th>
              <th style="min-width: 150px">Plan Date</th>
              <th style="min-width: 150px">PIC Drafter</th>
              <th style="min-width: 150px">Outstanding</th>
              <th style="min-width: 150px">Completed</th>
              <th style="min-width: 250px">Storage</th>
              <th style="min-width: 200px">Transmittal Number</th>
              <th style="min-width: 200px">Transmittal Date</th>
              <th style="min-width: 200px">Date Receive</th>
              <th style="min-width: 250px">Aksi</th>
            </tr>
          </template>

          <template #defaultBody="{ item, i }">
            <tr v-bind:key="i">
              <td class="pl-0 ">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.numbering }}
                </span>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.external_numbering }}
                    </span>
                  </template>

                  <template #onEdit>
                    <input
                      class="form-control"
                      v-model="currentEditForm.external_numbering"
                    />
                  </template>
                </on-edit-row>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onEdit>
                    <input
                      class="form-control"
                      v-model="currentEditForm.asbuilt_drawing_numbering"
                    />
                  </template>

                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.asbuilt_drawing_numbering }}
                    </span>
                  </template>
                </on-edit-row>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.title }}
                </span>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.station ? item.station.name : "-" }}
                </span>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.type ? item.type.name : "-" }}
                </span>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.scope ? item.scope.name : "-" }}
                </span>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onEdit>
                    <b-form-select
                      v-model="currentEditForm.status"
                      :options="formattedStatusOptions"
                      size="lg"
                    ></b-form-select>
                  </template>

                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.last_status ? item.last_status.name : "-" }}
                    </span>
                  </template>
                </on-edit-row>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onEdit>
                    <input
                      class="form-control"
                      v-model="currentEditForm.revision_version"
                    />
                  </template>

                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.revision_version }}
                    </span>
                  </template>
                </on-edit-row>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onEdit>
                    <input
                      class="form-control"
                      v-model="currentEditForm.version"
                    />
                  </template>

                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.version }}
                    </span>
                  </template>
                </on-edit-row>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onEdit>
                    <input
                      class="form-control"
                      v-model="currentEditForm.plan_date"
                      type="date"
                    />
                  </template>

                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.plan_date }}
                    </span>
                  </template>
                </on-edit-row>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onEdit>
                    <b-form-select
                      v-model="currentEditForm.drafter_pic"
                      :options="formattedPicOptions"
                      size="lg"
                    ></b-form-select>
                  </template>

                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.drafter_pic ? item.drafter_pic.name : "-" }}
                    </span>
                  </template>
                </on-edit-row>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onEdit>
                    <b-form-select
                      v-model="currentEditForm.outstanding"
                      :options="formattedOutstandingOptions"
                      size="lg"
                    ></b-form-select>
                  </template>

                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.outstanding ? item.outstanding.name : "-" }}
                    </span>
                  </template>
                </on-edit-row>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.date_completed }}
                </span>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onEdit>
                    <template>
                      <div class="custom-file">
                        <input
                          type="file"
                          class="custom-file-input"
                          id="customFile"
                        />

                        <label class="custom-file-label" for="customFile"
                          >Choose file</label
                        >
                      </div>
                    </template>
                  </template>

                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.asbuilt_file }}
                    </span>
                  </template>
                </on-edit-row>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.transmittal_number }}
                </span>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onEdit>
                    <input
                      class="form-control"
                      type="date"
                      v-model="currentEditForm.transmittal_date"
                    />
                  </template>

                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.transmittal_date }}
                    </span>
                  </template>
                </on-edit-row>
              </td>

              <td>
                <on-edit-row :is-edit="isEdit(item.id)">
                  <template #onEdit>
                    <input
                      class="form-control"
                      type="date"
                      v-model="currentEditForm.date_receive"
                      id="example-date-input"
                    />
                  </template>

                  <template #onView>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.date_receive }}
                    </span>
                  </template>
                </on-edit-row>
              </td>

              <td class="pr-0">
                <div class="d-flex">
                  <on-edit-row :is-edit="isEdit(item.id)">
                    <template #onView>
                      <a
                        class="btn btn-light-success font-weight-bolder font-size-sm mr-2"
                        @click="editData(item)"
                      >
                        <i class="flaticon-edit"></i>
                      </a>
                    </template>

                    <template #onEdit>
                      <a
                        class="btn btn-light-danger font-weight-bolder font-size-sm mr-2"
                        @click="cancelEdit"
                      >
                        <i class="flaticon2-cross"></i>
                      </a>
                    </template>
                  </on-edit-row>
                </div>
              </td>
          </tr>
          </template>
        </complete-table>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { mapState } from "vuex";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import { GET_PROJECT_DETAIL } from "../../../core/services/store/project.module";
import { GET_OUTSTANDING } from "../../../core/services/store/outstanding.module";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
import {
  GET_AS_BUILT_DRAWING,
  UPDATE_AS_BUILT_DRAWING
} from "../../../core/services/store/asbuilt-drawing.module";
import OnEditRow from "../../content/widgets/advance-table/row/OnEditRow";
import { GET_PIC } from "../../../core/services/store/pic.module";
import { GET_STATUS_OPTION } from "../../../core/services/store/status.module";

export default {
  name: "MonitoringAsbuiltDrawing",
  components: { OnEditRow, CompleteTable },
  data() {
    return {
      currentEditId: null,
      currentEditForm: {
        external_numbering: null,
        asbuilt_drawing_numbering: null,
        status: null,
        revision_version: null,
        version: null,
        plan_date: null,
        drafter_pic: null,
        outstanding: null,
        storage: null,
        transmittal_date: null,
        date_receive: null
      },
      currentItem: null,
      filter: {
        id_project: null,
        nickname: null,
        station: null,
        scope: null,
        job_desk: "design",
        code: null
      },
      selectedNickname: {
        ownerName: null,
        projectName: null,
        status: null,
        contractNumber: null,
        code: null
      }
    };
  },
  computed: {
    ...mapState({
      outstandings: state => state.outstanding.outstanding?.data,
      projects: state => state.projectDetails.projectDetails?.data,
      asBuiltDrawing: state => state.asBuiltDrawing.asBuiltDrawing,
      loading: state => state.asBuiltDrawing.loading,
      pics: state => state.pic.pics?.data,
      statuses: state => state.status.status?.data
    }),

    currentAsBuiltDrawings() {
      return this.asBuiltDrawing?.data ?? [];
    },

    formattedProjectOptions() {
      let projects = [];

      if (arrayMoreThanOne(this.projects)) {
        projects = this.projects.map(project => {
          return {
            value: project.code,
            text: project.nickname
          };
        });
      }

      return [{ value: null, text: "Pilih Nickname" }, ...projects];
    },

    formattedPicOptions() {
      let pics = [];

      if (arrayMoreThanOne(this.pics)) {
        pics = this.pics.map(pic => {
          return {
            value: pic.code,
            text: pic.name
          };
        });
      }

      return [{ value: null, text: "Pilih PIC" }, ...pics];
    },

    formattedOutstandingOptions() {
      let outstanding = [];

      if (arrayMoreThanOne(this.outstandings)) {
        outstanding = this.outstandings.map(scope => {
          return {
            value: scope.code,
            text: scope.name
          };
        });
      }

      return [{ value: null, text: "Pilih Outstanding" }, ...outstanding];
    },

    formattedStatusOptions() {
      let status = [];

      if (arrayMoreThanOne(this.statuses)) {
        status = this.statuses.map(scope => {
          return {
            value: scope.code,
            text: scope.name
          };
        });
      }

      return [{ value: null, text: "Pilih Status" }, ...status];
    },

    currentNickname() {
      return this.filter.nickname;
    }
  },
  watch: {
    currentNickname(value) {
      if (!value) {
        Object.assign(this.selectedNickname, {
          ownerName: null,
          projectName: null,
          status: null,
          contractNumber: null,
          code: null
        });

        return;
      }

      const project = this.projects.find(
        project => project.code === this.filter.nickname
      );

      Object.assign(this.selectedNickname, {
        ownerName: project?.owner,
        projectName: project?.name,
        status: project?.status,
        contractNumber: project?.contract_no,
        ...project
      });
    }
  },
  methods: {
    loadData() {
      if (!this.filter.nickname) {
        this.$bvToast.toast("Pilih nickname terlebih dahulu.", {
          title: "Warning",
          variant: "warning",
          solid: true
        });
      } else {
        this.getAsBuiltDrawings();
      }
    },

    editData(item) {
      this.currentEditId = item.id;

      this.currentItem = item;

      this.currentEditForm = {
        external_numbering: item.external_numbering,
        asbuilt_drawing_numbering: item.asbuilt_drawing_numbering,
        status: item.last_status?.code,
        revision_version: item.revision_version,
        version: item.version,
        plan_date: item.plan_date,
        drafter_pic: item.drafter_pic?.code,
        outstanding: item.outstanding?.code,
        storage: item.asbuilt_file,
        transmittal_date: item.transmittal_date,
        date_receive: item.date_receive
      };
    },

    cancelEdit() {
      this.currentEditId = null;

      this.currentEditForm = {
        external_numbering: null,
        asbuilt_drawing_numbering: null,
        status: null,
        revision_version: null,
        version: null,
        plan_date: null,
        drafter_pic: null,
        outstanding: null,
        storage: null,
        transmittal_date: null,
        date_receive: null
      };

      this.currentItem = null;
    },

    save() {
      const status = this.formattedStatusOptions.find(
        status => status.value === this.currentEditForm.status
      );

      const outstanding = this.formattedOutstandingOptions.find(
        outstanding => outstanding.value === this.currentEditForm.outstanding
      );

      const pic = this.formattedPicOptions.find(
        pic => pic.value === this.currentEditForm.drafter_pic
      );

      const cleanForm = {
        id: this.currentItem.id,
        external_numbering: this.currentEditForm.external_numbering,
        asbuilt_drawing_numbering: this.currentEditForm
          .asbuilt_drawing_numbering,
        status: {
          code: status?.value,
          name: status?.text
        },
        revision_version: this.currentEditForm.revision_version,
        version: this.currentEditForm.version,
        drafter_pic: {
          code: pic?.value,
          name: pic?.text
        },
        outstanding: {
          code: outstanding?.value,
          name: outstanding?.text
        },
        asbuilt_file: this.currentEditForm.storage,
        transmittal_date: this.currentEditForm.transmittal_date,
        date_received: this.currentEditForm.date_receive,
        plan_date: this.currentEditForm.plan_date
      };

      this.$store
        .dispatch(UPDATE_AS_BUILT_DRAWING, { dld: [cleanForm] })
        .then(() => {
          this.cancelEdit();
        });
    },

    toEditPage() {
      //
    },

    getAsBuiltDrawings() {
      this.$store.dispatch(GET_AS_BUILT_DRAWING, {
        params: {
          ...this.filter,
          project_code: this.currentNickname
        }
      });
    },

    getShowName(item) {
      const index = this.options.pics.findIndex(
        pic => pic.value === item.pic_drafter.id
      );

      return this.options.pics[index]?.text;
    },

    getShowOutStanding(item) {
      const index = this.options.outstandings.findIndex(
        pic => pic.value === item.outstanding.id
      );

      return this.options.outstandings[index]?.text;
    },

    getProjects() {
      if (!arrayMoreThanOne(this.projects)) {
        this.$store.dispatch(GET_PROJECT_DETAIL, { jobdesk: "design" });
      }
    },

    getOutstandings() {
      if (!arrayMoreThanOne(this.outstandings)) {
        this.$store.dispatch(GET_OUTSTANDING, this.filter);
      }
    },

    getStatuses() {
      if (!arrayMoreThanOne(this.statuses)) {
        this.$store.dispatch(GET_STATUS_OPTION, {});
      }
    },

    getPics() {
      if (!arrayMoreThanOne(this.pics)) {
        this.$store.dispatch(GET_PIC, {});
      }
    },

    isEdit(id) {
      return id === this.currentEditId;
    }
  },
  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [
      { title: "Monitor Asbuilt Drawing" }
    ]);

    this.getOutstandings();

    this.getProjects();

    this.getPics();

    this.getStatuses();
  }
};
</script>

<style></style>
